#######################################
#  judge.tcl

proc judge {} {
    global j score filled

    if {$j == 1} {
	set a [judge_player]
	if {$a == 1} {
	    return 1
	}
	return 0
    } elseif {$j == 2} {
	set a [judge_com]
	if {$a == 1} {
	    return 1
	}
	return 0
    } else {
	return 2
    }
}

proc judge_player {} {
    global stat ok

    if {$stat(try) == 1} {
	set a [judge1]
	if {$a == 1} {
	    return 1
	}
    } elseif {$stat(try) == 2} {
	judge2
    } else {
	return
    }
    set ok(select) 1
    return 0
}

proc count1 {} {
    global dice stat j count 
    
    for {set k 1} {$k <= 6} {incr k} {
	set count($k) 0
    }

    for {set i 1} {$i <= 5} {incr i} {
	for {set k 1} {$k <= 6} {incr k} {
	    if {$dice($i) == $k} {
		incr count($k)
		break
	    }
	}
    }
}

proc count2 {} {
    global stat j count max filled

    for {set i 1} {$i <= 6} {incr i} {
	set max($i) $count($i)
    }

    for {set i 1} {$i <= 6} {incr i} {
	set k [expr 7 - $i]
	if {$count($k) >= 1} {
	    incr max($i)
	    if {$count($k) >= 2} {
		incr max($i)
	    }
	}
	if {$stat(turned) == 0 && $count($i) == 5} {
	    set max($i) 4
	} 
    }
}

proc judge1 {} {
    global ok

    count1
    count2
    count_group

    judge_16_1
    judge_escalera1
    judge_ful1
    judge_poca1
    set a [judge_dormida]
    if {$a == 1} {
	return 1
    } else {
	set ok(select) 1
	return 0
    }
}

proc judge2 {} {
    global stat ok

    count1
    count2
    count_group

    set stat(num) 0

    judge_16_2
    judge_escalera2
    judge_ful2
    judge_poca2
    judge_grande
    if {$stat(num) == 0} {
	XXX
    } 
    set ok(select) 1
    if {$stat(game) == 11} select_only1
}

proc judge_16_1 {} {
    global stat j count filled

    for {set i 1} {$i <= 6} {incr i} {
	if {$filled($i$j) == 0} {
	    if {$count($i) > 0} {
		yesyes $i
	    } else {
		nono $i
	    }
	}
    }
}

proc judge_16_2 {} {
    global stat j count max filled

    for {set i 1} {$i <= 6} {incr i} {
	if {$filled($i$j) == 0} {
	    if {$max($i) > 0} {
		yesyes $i
	    } else {
		nono $i
	    }
	}
    }
}

proc judge_escalera1 {} {
    global ldice stat j filled score demano

    if {$filled(e$j) == 1 && $score(e$j) != 25} {
	return
    }

    set e1 "0 1 2 3 4 5"
    set e2 "0 2 3 4 5 6"
    set e3 "0 1 3 4 5 6"

    set sorted [lsort -integer $ldice]

    if {$sorted == $e1 || $sorted == $e2 || $sorted == $e3} {
	if {$j == 1 && $demano(e$j) > 0} {
	    demano2 e
	    return
	}
	set stat(demano) 1
	yesyes e
    } else {
	set stat(demano) 0
	nono e
    }
}

proc judge_escalera2 {} {
    global stat ldice j count max filled

    if {$filled(e$j) == 1} return

    if {$max(3) != 2} {
	nono e
	return
    }

    for {set i 1} {$i <= 6} {incr i} {
	if {$max($i) >= 3} {
	    nono e
	    return
	}
    }
    set e1 "0 1 1 2 4 4"
    set e2 "0 1 1 2 3 3"
    set e3 "0 2 4 4 6 6"
    set e4 "0 2 3 3 6 6"
    set sorted [lsort -integer $ldice]

    if {$sorted == $e1 || $sorted == $e2 \
	    || $sorted == $e3 || $sorted == $e4} {
	nono e
    } else {
	yesyes e
    }    
}

proc judge_ful1 {} {
    global stat j demano count max filled score
 
    if {$stat(demano) == 1} return

    if {$filled(f$j) == 1 && $score(f$j) != 35} {
	return
    }

    set k 0
    for {set i 1} {$i <= 6} {incr i} {
	if {$count($i) == 2} {
	    incr k 2
	} elseif {$count($i) == 3} {
	    incr k 3
	}
    }
    if {$k == 5} {
	if {$j == 1 && $demano(f$j) > 0} {
	    demano2 f
	    return
	} 
	set stat(demano) 1
	yesyes f
    } else {
	set stat(demano) 0
	nono f
    }
}
    
proc judge_ful2 {} {
    global stat j count max filled

    if {$filled(f$j) != 0} return

    for {set i 1} {$i <= 6} {incr i} {
	if {$max($i) == 5} {
	    yesyes f
	    return
	}
    }
    for {set i 1} {$i <= 6} {incr i} {
	if {$max($i) == 1 || $max($i) == 4} {
	    nono f
	    return
	}
    }
    yesyes f
}

proc judge_poca1 {} {
    global stat j count filled demano score

    if {$stat(demano) == 1} return
    if {$filled(p$j) == 1 && $score(p2) != 45} {
	return
    }

    for {set i 1} {$i <= 6} {incr i} {
	if {$count($i) == 4} {
	    if {$j == 1 && $demano(p$j) > 0} {
		demano2 p
		return
	    }
	    set stat(demano) 1
	    yesyes p
	    break
	} else {
	    set stat(demano) 0
	    nono p
	}
    }
}

proc judge_poca2 {} {
    global stat j count max filled

    if {$filled(p$j) != 0} return

    for {set i 1} {$i <= 6} {incr i} {
	if {$max($i) >= 4} {
	    yesyes p
	    return
	}
    }
    nono p
}

proc judge_dormida {} {
    global stat j msg msgs count filled color total

    for {set i 1} {$i <= 6} {incr i} {
	if {$count($i) == 5} {
	    set msg $msgs(dormida)
	    applause .field.player$j.label -bg $color(0) $color(winner) 100 10
	    fever 5 4
	    set total($j) "Infinity!!!"
	    game_end
	    return 1
	}
    }
    return 0
}

proc judge_grande {} {
    global stat j grande ok count max filled score

    set stat(grande) 0

    for {set i 1} {$i <= 6} {incr i} {
	if {$max($i) == 5} {
	    incr stat(grande)
	    break
	}
    }

    if {$stat(grande) == 0} {
	for {set i 1} {$i <= 2} {incr i} {
	    if {$filled(g$i$j) == 0} {
		nono g$i
	    }
	}
	return
    }

    if {$grande($j) < 2} {
	for {set i 1} {$i <= 2} {incr i} {
	    if {$filled(g$i$j) == 0} {
		yesyes g$i
		break
	    }
	} 
    } else {
	if {$score(g2$j) != 50} {return}
	for {set i 1} {$i <= 6} {incr i} {
	    if {$filled($i$j) == 0} {
		yesyes $i
		set score($i$j) [expr 5*$i]
	    }
	}
	if {$filled(e$j) == 0} {
	    yesyes e
	    set score(e$j) 25
	}
	if {$filled(f$j) == 0} {
	    yesyes f
	    set score(f$j) 35
	}
	if {$filled(p$j) == 0} {
	    yesyes p
	    set score(p$j) 45
	}
	set ok(g1$j) 0
	set ok(g2$j) 0
    }

}

proc nono {c} {
    global j ok filled score

    set ok($c$j) 0
    if {$filled($c$j) == 0} {
	set score($c$j) ""
	relief_sheet $c groove
    }
}

proc yesyes {c} {
    global stat j opt ok filled msg msgs

    set ok($c$j) 1
    if {$opt(advice) == 1} {
	if {$stat(try) == 1 && $stat(demano) == 1 && $filled($c$j) == 0} {
	    set msg $msgs(${c}demano)
	    relief_sheet $c raised
	    emph_sheet $c
	} elseif {$stat(try) == 2} {
	    relief_sheet $c raised
	    emph_sheet $c
	}
    }
    if {$filled($c$j) == 0} {
	set score($c$j) ""
    }
    incr stat(num)
}

proc demano2 {c} {
    global j stat msg msgs demano

    switch $c {
	e {set str "Escalera de mano"}
	f {set str "Ful de mano"}
	p {set str "Poca de mano"}
    }

    set time [expr $demano($c$j) + 1]
    if {$time == 2} {
	set time "2nd"
    } elseif {$time == 3} {
	set time "3rd"
    } else {
	set time "${time}th"
    }

    set ans [tk_messageBox -parent . \
	    -title "$time $str" \
	    -type yesno \
	    -message "You got $time $str. Throw again?"]

    switch $ans {
	yes {
	    init_sheet 
	    init_dice
	    active_throw
	    set stat(demano) 0
	    nono $c
	}
	no {return}
    }

    if {$stat(otetsuki) == 0} {
	incr demano($c$j)
    }
}

proc XXX {} {
    global stat j ok filled score

    for {set i 1} {$i <= 6} {incr i} {
	set_X $i
    }
    set_X e
    set_X f
    set_X p
    for {set i 1} {$i <= 2} {incr i} {
	set k [set_X g$i]
	if {$k == 1} break
    }
}

proc set_X {c} {
    global filled score ok j

    if {$filled($c$j) == 0} {
	set score($c$j) "X"
	set ok($c$j) 1
	relief_sheet $c raised
	return 1
    } else {
	return 0
    }
}

proc emph_sheet {c} {
    global j color

    switch $c {
	1 -
	2 -
	3 {
	    .field.player${j}.sheet.sheet1.score$c configure -bg $color(emph)
	}
	4 -
	5 -
	6 {
	    .field.player${j}.sheet.sheet2.score$c configure -bg $color(emph)		
	}
	e -
	f -
	p {
	    .field.player${j}.sheet.sheet3.$c configure -bg $color(emph)
	    
	}
	g1 -
	g2 {
	    .field.player${j}.grande.$c configure -bg $color(emph)
	}
    }
}

####################################################
# for computer
proc judge_com {} {
    global stat j demano grande msg msgs dice ldice ok
    global opt

    set a [judge1]
    if {$a == 1} {
	return 1
    }

    delay $opt(delay)

    if {$ok(e$j) == 1} {
	set a [edemano]
	if {$a == 0} {
	    return 0
	} else {
	    throw_com2
	    return 0
	}
    } elseif {$ok(f$j) == 1} {
	set a [fdemano]
	if {$a == 0} {
	    return 0
	} else {
	    throw_com2
	    return 0
	}
    } elseif {$ok(p$j) ==1} {
	set a [pdemano]
	if {$a == 0} {
	    return 0
	} else {
	    throw_com2
	    return 0
	}
    } 

    switch $stat(group) {
	113 {choice113}
	122 {choice122}
	023 {choice23}
	014 {choice14}
    }
 
    throw_com2

    return 0
}

proc throw_com2 {} {
    global ok stat opt msg msgs

    set stat(try) 2
    .belt.try.try configure -text "2nd:"

    delay $opt(delay)

    throw2
    set_dice
    set ok(change) 0
    set ok(turn) 1
    set msg $msgs(turn)
    nonactive_throw
    set ok(select) 1

    judge2

    delay $opt(delay)

    if {$stat(num) >= 1} {
	select_com
    } else {
	select_X
    }
}

proc count_group {} {
    global stat dice group

    set group(1) 0;           # 1 or 6
    set group(2) 0;           # 2 or 5            
    set group(3) 0;           # 3 or 4
    for {set i 1} {$i <= 5} {incr i} {
	if {$dice($i) == 1 || $dice($i) == 6} {
	    incr group(1)
	} elseif {$dice($i) == 2 || $dice($i) == 5} {
	    incr group(2)
	} else {
	    incr group(3)
	}
    }

    set l [list $group(1) $group(2) $group(3)]
    set l [lsort -integer $l]
    set a [lindex $l 0]
    set b [lindex $l 1]
    set c [lindex $l 2]

    set stat(group) $a$b$c
}

proc edemano {} {
    global j demano msg opt

    if {$demano(e$j) >= 1} {
	demano2_com e
	return 0
    } else {
	set msg "Escalera de mano!"
	delay $opt(delay)
	select e
	return 0
    }
    return 1
}

proc fdemano {} {
    global stat j demano grande msg msgs dice ldice filled
    global cmp ok score group count opt total

    if {$j == 2} {
	set j2 1
    } else {
	set j2 2
    }

    for {set i 1} {$i <= 6} {incr i} {
	if {$count($i) == 2} {
	    set a $i
	} elseif {$count($i) == 3} {
	    set b $i
	}
    }
    set c [expr $a + $b]

    if {$filled(f$j) == 0 && $c != 7} {
	set msg "Ful de mano!"
	delay $opt(delay)
	select f
	return 0
    }

    set r1 [random100]
    if {$demano(f$j) > 0} {
	if {$filled(p$j) == 0 || $filled($b$j) == 0} {
	    if {$r1 <= 99} {
		set case 2
	    } else {
		set case 4
	    }
	} elseif {$filled($a$j) == 0} {
	    if {$r1 <= 50} {
		set case 3
	    } else {
		set case 4
	    }
	} else {
	    if {$grande($j) < $grande($j2)} {
		if {$filled(p$j2) == 1 && $score(p$j2) == "X"} {
		    set d [expr $total($j) + 40]
		    if {$r1 <= 70 || $total($j) <= $total($j2)} {
			set case 2
		    } else {
			if {$r1 <= 50} {
			    set case 4
			} else {
			    set case 5
			}
		    }
		}
	    } else {
		if {$r1 <= 50} {
		    set case 4
		} else {
		    set case 5
		}
	    }
	}
    } elseif {$score(g2$j) == "X"} {
	set case 1
    } elseif {$filled($b$j) == 0} {
	set d [expr $total($j) + 35]
	if {$r1 <= 30 || $d < $total($j2)} {
	    set case 2
	} else {
	    set case 1
	}
    } else {
	if {$stat(game) > $cmp(chuban)} {
	    if {$r1 <= 95} {
		set case 1
	    } else {
		set case 2
	    }
	} else {
	    if {$r1 <= 70} {
		set case 1
	    } else {
		set case 2
	    }
	}
    }

    switch $case {
	1 {
	    set msg "Ful de mano!"
	    delay $opt(delay)
	    select f
	    return 0
	}
	2 {
	    for {set i 1} {$i <= 5} {incr i} {
		if {$dice($i) == $a} {
		    change $i
		    if {$c == 7} break;
		}
	    }
	    return 1
	}
	3 {
	    for {set i 1} {$i <= 5} {incr i} {
		if {$dice($i) == $a} {
		    change $i
		}
	    }
	    return 1
	}
	4 {
	    demano2_com f
	    return 0
	}
	5 {
	    choice23
	    return 1
	}
    }
    
# Never reach here
    return 2
}

proc pdemano {} {
    global stat j demano grande msg msgs dice ldice filled
    global cmp ok count score opt

    if {$j == 2} {
	set j2 1
    } else {
	set j2 2
    }

    for {set i 1} {$i <= 6} {incr i} {
	if {$count($i) == 1} {
	    set a $i
	} elseif {$count($i) == 4} {
	    set b $i
	}
    }
    set c [expr $a + $b]
    
    set r1 [random100]
    if {$demano(p$j) > 0} {
	if {$filled($b$j) == 0} {
	    if {$c == 7} {
		set case 3
	    } else {
		set case 2
	    }
	} else {
	    if {$stat(game) > $cmp(chuban)} {
		if {$filled(f$j) == 0} {
		    set case 3
		} else {
		    if {$score(g2$j) != "X"} {
			set case 3
		    } else {
			if {$r1 <= 50} {
			    set case 4
			} else {
			    set case 5
			}
		    }
		}
	    } else {
		if {$filled(f$j) == 0} {
		    set case 3
		} else {
		    if {$score(g2$j) != "X"} {
			set case 3
		    } else {
			if {$r1 <= 50} {
			    set case 4
			} else {
			    set case 5
			}
		    }
		}
	    }
	}
    } else {
	if {$stat(game) > $cmp(chuban)} {
	    set case 1
	} else {
	    if {$score(g2$j) == "X"} {
		set case 1
	    } else {
		if {$filled($b$j) == 0} {
		    if {$r1 <= 10} {
			set case 1
		    } else {
			if {$c == 7} {
			    set case 3
			} else {
			    set case 2
			}
		    }
		} else {
		    if {$c == 7} {
			if {$r1 <= 20} {
			    set case 1
			} else {
			    set case 3
			} 
		    } else {
			if {$r1 <= 50} {
			    set case 1
			} else {
			    set case 2
			} 
		    }
		}
	    }
	}
    }

    switch $case {
	1 {
	    set msg "Poca de mano!"
	    delay $opt(delay)
	    select p
	    return 0
	}
	2 {
	    for {set i 1} {$i <= 5} {incr i} {
		if {$dice($i) == $a} {
		    change $i
		    break;
		}
	    }
	    return 1
	}
	3 {
	    for {set i 1} {$i <= 5} {incr i} {
		if {$dice($i) == $b} {
		    change $i
		    break;
		}
	    }
	    return 1
	}
	4 {
	    demano2_com p
	    return 0
	}
	5 {
	    choice14
	    return 1
	}
    }
    return
}
    
proc demano2_com {c} {
    global j stat msg demano opt ok

    delay $opt(delay)
    
    switch $c {
        e {set str "Escalera de mano"}
        f {set str "Ful de mano"}
        p {set str "Poca de mano"}
    }

    set time [expr $demano($c$j) + 1]
    if {$time == 2} {
        set time "2nd"
    } elseif {$time == 3} {
        set time "3rd"
    } else {
        set time "${time}th"
    }

    set str "$time $str! I'll throw again!"
    set msg $str

    delay $opt(delay)

    init_sheet 
    init_dice
    set stat(try) 1
    set stat(changed) 0
    set stat(otetsuki) 0
    set stat(turned) 0
    set ok(change) 0
    set ok(turn) 0
    set ok(select) 0
    set stat(demano) 0
    set stat(grande) 0
    incr demano($c$j)
    active_throw
    .belt.try.try configure -text "1st:"
    nono $c

    throw
    return
}

set cmp(edemano)  95
set cmp(edemano2) 99
set cmp(fdemano)  90
set cmp(fdemano2) 70
set cmp(pdemano)  20
set cmp(half) 50

set cmp(joban) 3
set cmp(chuban) 7

proc change2 {c num} {
    global dice;

    set k 0
    for {set i 1} {$i <= 5} {incr i} {
	if {$dice($i) == $c} {
	    change $i
	    incr k
	}
	if {$k == $num} {
	    return
	}
    }
}

proc keep3 {num} {
    global dice group changed

    for {set i 1} {$i <= 3} {incr i} {
	if {$group($i) == $num} {
            set c $i
	    break
	}
    }
    
    set c2 [expr 7 - $c]

    for {set i 1} {$i <= 5} {incr i} {
	if {$changed($i) == 0} {
	    change $i
	}
    }

    set k 0
    for {set i 1} {$i <= 5} {incr i} {
	if {$dice($i) == $c || $dice($i) == $c2} {
	    change $i
	    incr k
	}
	if {$k == $num} {
	    return
	}
    }
}
