#######################################################
#  select.tcl

proc select {c} {
    global stat j grande demano ok count max score
    global total filled opt

    if {$ok(select) != 1} return
    if {$c == "g"} {
	if {$filled(g1$j) == 0} {
	    set c "g1"
	} else {
	    set c "g2"
	}
    } 
    if {$ok($c$j) != 1}	return

    if {$stat(num) > 0} {
	switch $c {
	    e {
		if {$stat(try) == 1} {
		    set score(e$j) 25
		    incr demano(e$j)
		} elseif {$stat(grande) > 0 && $grande($j) >= 2} {
		    set score(e$j) 25
		    incr grande($j)
		} else {
		    set score(e$j) 20
		}
		incr total($j) $score(e$j) 
	    }
	    f {
		if {$stat(try) == 1} {
		    set score(f$j) 35
		    incr demano(f$j)
		} elseif {$stat(grande) > 0 && $grande($j) >= 2} {
		    set score(f$j) 35
		    incr grande($j)
		} else {
		    set score(f$j) 30
		}
		incr total($j) $score(f$j) 
	    }
	    p {
		if {$stat(try) == 1} {
		    set score(p$j) 45
		    incr demano(p$j)
		} elseif {$stat(grande) > 0 && $grande($j) >= 2} {
		    set score(p$j) 45
		    incr grande($j)
		} else {
		    set score(p$j) 40
		}
		incr total($j) $score(p$j) 
	    }
	    g1 -
	    g2 {
		set score($c$j) 50
		incr total($j) $score($c$j) 
		incr grande($j)
	    }
	    1 -
	    2 -
	    3 -
	    4 -
	    5 -
	    6 {
		if {$stat(try) == 1} {
		    set score($c$j) [expr $c*$count($c)]
		} elseif {$grande($j) >= 2 && $stat(grande) > 0} {
		    set score($c$j) [expr $c*5]
		    incr grande($j)
		} else {
		    set score($c$j) [expr $c*$max($c)]
		}
		incr total($j) $score($c$j) 
	    }
	}
    }

    fill_sheet $c
    change_player

}
 
proc fill_sheet {c} {
    global stat j ok filled

    set filled($c$j) 1
    set ok($c$j) 0
    relief_sheet $c ridge

}

proc change_player {} {
    global stat j color msg msgs changed turned total ok opt

    clear_dice

    .field.player$j.label configure -bg $color(0)
    init_sheet

    if {$j == 1} {
	set j 2
	set j2 1
	if {$stat(game) == 11 && $total($j) > $total($j2)} {
	    winner
	    return
	}
    } elseif {$j == 2} {
	set j 1
	set j2 1
	if {$stat(game) == 11} {
	    winner
	    return
	}
	incr stat(game)
    }
	
    .field.player$j.label configure -bg $color(current)

    set msg $msgs(player$j)
 
    set stat(try) 1
    set stat(changed) 0
    set stat(otetsuki) 0
    set stat(turned) 0
    set stat(demano) 0
    set stat(grande) 0
    set ok(change) 0
    set ok(turn) 0
    set ok(select) 0
    .belt.try.try configure -text "1st:"
    active_throw
    
    if {$j == 2} {
	delay $opt(delay)
	throw
   } 
}

proc select_only1 {} {
    global j ok opt

    delay $opt(delay)
    for {set i 1} {$i <= 6} {incr i} {
	if {$ok($i$j) == 1} {
	    select $i
	    return
	}
    }

    foreach c {e f p} {
	if {$ok($c$j) == 1} {
	    select $c
	    return
	}
    }

    foreach c {g1 g2} {
	if {$ok($c$j) == 1} {
	    select g
	    return
	}
    }
}

##################################################################
##############################################################
proc select_com {} {
    global stat j max group ok cmp grande opt

    if {$stat(grande) == 1 && $grande($j) >= 2} {
	delay $opt(delay)
	
	set time [expr $grande($j) + 1]
	if {$time == 3} {
	    set time "3rd"
	} else {
	    set time "${time}th"
	}
	set str "$time Grande !!!"
	set msg $str

	delay $opt(delay)

	for {set i 6} {$i >= 5} {incr i -1} {
	    if {$ok($i$j) == 1} {
		select $i
		return 0
	    }
	}

	foreach c {e f p} {
	    if {$ok($c$j) == 1} {
		select $c
		return 0
	    }
	}
	
	for {set i 4} {$i >= 1} {incr i -1} {
	    if {$ok($i$j) == 1} {
		select $i
		return 0
	    }
	}
    }

    foreach c {g1 g2} {
	if {$ok($c$j) == 1} {
	    select g
	    return 0
	}
    }

    foreach c {e f} {
	if {$ok($c$j) == 1} {
	    select $c
	    return 0
	}
    }

    for {set i 6} {$i >= 1} {incr i -1} {
	if {$max($i) >= 4 && $ok(${i}$j) == 1} {
	    select $i
	    return 0
	}
    }
    

    for {set i 1} {$i <= 6} {incr i} {
	if {$max($i) >= 3 && $ok(${i}$j) == 1} {
	    if {$i == 6} {
		if {$ok(p$j) == 1} {
		    select p
		    return 0
		} elseif {$ok(1$j) == 1} {
		    select 1
		    return 0
		}
	    }
	    select $i
	    return 0
	}
    }

    if {$ok(p$j) == 1} {
	select p
	return 0
    }

   for {set i 1} {$i <= 2} {incr i} {
	if {$max($i) >= 1 && $ok(${i}$j) == 1} {
	    select $i
	    return 0
	}
    }

    for {set i 3} {$i <= 6} {incr i} {
	if {$max($i) >= 2 && $ok(${i}$j) == 1} {
	    select $i
	    return 0
	}
    }
    for {set i 3} {$i <= 6} {incr i} {
	if {$max($i) >= 1 && $ok(${i}$j) == 1} {
	    select $i
	    return 0
	}
    }

    return 1
}
    
proc select_X {} {
    global stat j count max group ok cmp grande

    if {$j == 2} {
	set j2 1
    } else {
	set j2 2
    }

    for {set i 1} {$i <= 2} {incr i} {
	if {$ok($i$j) == 1} {
	    select $i
	    return 0
	} 
    }

    if {$grande($j) >= $grande($j2)} {
	for {set i 1} {$i <= 2} {incr i} {
	    if {$ok(g$i$j) == 1} {
		select g
		return 0
	    }
	}
	select_X2
	return 0
    } else {
	set a [select_X2]
	if {$a == 0} {
	    return 0
	} else {
	    for {set i 1} {$i <= 2} {incr i} {
		if {$ok(g$i$j) == 1} {
		    select g
		    return 0
		}
	    }
	}
    }

# Never comes here
    return 1
}

proc select_X2 {} {
    global stat j group ok cmp grande

    for {set i 3} {$i <= 4} {incr i} {
	if {$ok($i$j) == 1} {
	    select $i
	    return 0
	} 
    }

    if {$ok(e$j) == 1} {
	select e
	return 0
    } else {
	for {set i 5} {$i <= 6} {incr i} {
	    if {$ok($i$j) == 1} {
		select $i
		return 0
	    } 
	}
	if {$ok(f$j) == 1} {
	    select f
	    return 0
	} elseif {$ok(p$j) == 1} {
	    select p
	    return 0
	}
    }

    return 1
}

