#########################################################
#   config_cacho.tcl
#  color
set color(0) "white"
set color(1) "red"
set color(dormida) "red"
set color(current) "red"
set color(winner) "red"
set color(throw) "yellow"
set color(sheet) "lightblue"
set color(emph) "pink"

#  Cacho for Linux 
#    Key bind definition
bind all <Return> {throw}
bind all <Control-q> {exit}
bind all <Control-r> {newgame}
bind all <Control-n> {newgame}
bind all <Control-h> {help}
bind all <Control-a> {about}
bind all <Control-c> {destroy .help}
bind all <Key-z> {push_dice 1}
bind all <Key-x> {push_dice 2}
bind all <Key-c> {push_dice 3}
bind all <Key-v> {push_dice 4}
bind all <Key-b> {push_dice 5}
bind all <Key-1> {select 1}
bind all <Key-2> {select 2}
bind all <Key-3> {select 3}
bind all <Key-4> {select 4}
bind all <Key-5> {select 5}
bind all <Key-6> {select 6}
bind all <Control-e> {select e}
bind all <Control-f> {select f}
bind all <Control-p> {select p}
bind all <Control-g> {select g}

#############################################
#  Messages

set msgs(player1) "Player"
set msgs(player2) "Computer"
set msgs(again) "Change?"
set msgs(turn) "Turn?"
set msgs(1more) "You can choose 2 dice"
set msgs(which) "Which do you want?"
set msgs(win1) "You won!"
set msgs(win2) "You lost..."
set msgs(draw) "Draw!"
set msgs(edemano) "Escalera de-mano!"
set msgs(fdemano) "Ful de-mano!"
set msgs(pdemano) "Poca de-mano!"
set msgs(dormida) "Congraturation, Dormida !!!!!!!"

####################################################################