#########################################################
#  init_cacho.tcl

proc newgame {} {
    global stat j msg msgs color ok count max changed turned 
    global filled grande demano total

    for {set j 1} {$j <= 2} {incr j} {
	init_var $j
	active_throw
	cancel_count
	init_sheet
	paint_sheet $j $color(sheet)
    }
    init_dice
    init_stat

    set j 1
    .field.player1.label configure -bg $color(current)
    .field.player2.label configure -bg $color(0)

    .belt.try.try configure -text "1st:"

    set msg $msgs(player1)
}

proc init_stat {} {
    global stat ok

    set stat(game) 1
    set stat(try) 1
    set stat(changed) 0
    set stat(otetsuki) 0
    set stat(turned) 0
    set stat(demano) 0
    set stat(grande) 0
    set stat(num) 0
    set ok(change) 0
    set ok(turn) 0
    set ok(select) 0
}

proc init_var {k} {
    global filled total grande demano

    for {set i 0} {$i <= 6} {incr i} {
	set filled($i$k) 0;  
    }
    foreach i {e f p g1 g2} {
	set filled($i$k) 0
    }

    set total($k) 0;            # Total score
    set grande($k) 0

    foreach i {e f p} {
	set demano($i$k) 0
    }
}

proc init_sheet {} {
    global stat j ok filled

    for {set i 1} {$i <= 6} {incr i} {
	nono $i
    }

    foreach i {e f p g1 g2} {
	nono $i
    }
    
    set ok(select) 0
}

proc init_dice {} {
    global stat j turned changed
    
    for {set i 1} {$i <= 5} {incr i} {
	.dice.dice$i configure -relief groove \
		-borderwidth 3 -bitmap @1.xbm
	set turned($i) 0
	set changed($i) 0
    }
    set stat(turned) 0
    set stat(num) 0
}

proc cancel_count {} {
    global j count max

    for {set i 0} {$i <= 6} {incr i} {
	set count($i) 0
	set max($i) 0
    }
}

#################################################################
