##############################################################
#       TkCacho   Ver. 0.92                                  #    
#           main_cacho.tcl                                   # 
#                 by Y. Tsunesada                            #
############################################################## 
#  Global variables
global stat j dice ldice opt ver demano grande total
global count max changed turned score ok color filled

# Version
set ver 0.92

source config_cacho.tcl

# Create Main Window
source window.tcl

# Dice 
source dice.tcl

# judgement
source judge.tcl

# selection for filling sheet
source select.tcl
source choice.tcl

# some pocedures
source procs.tcl

# Initialization
source init_cacho.tcl

newgame

#########################################################
#  defaults:

#  Advice option (default: off)
set opt(advice) 0
# Dice action 
set opt(speed) 1
set opt(times) 7
# Computer Speed
set opt(delay) 500